.386
.model flat,stdcall
option casemap:none

include windows.inc
include user32.inc
include kernel32.inc
include gdi32.inc

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib

include masm32.inc
includelib masm32.lib

include color_izer.inc

      CADD MACRO quoted_text:VARARG
        LOCAL vname,lbl
          jmp lbl
            vname db quoted_text,0
          align 4
          lbl:
        EXITM <ADDR vname>
      ENDM
      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM
      RGB MACRO red, green, blue
        xor eax, eax
        mov ah, blue    ; blue
        mov al, green   ; green
        rol eax, 8
        mov al, red     ; red
      ENDM
      LOWORD MACRO bigword
        mov  eax,bigword
        and  eax,0FFFFh     ;; Set to low word
      ENDM
      HIWORD MACRO bigword
        mov eax,bigword
        shr eax,16
      ENDM
      m2m MACRO M1, M2
        mov eax,M2
        mov M1,eax
      ENDM
	
ColorDlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
Color_Init   PROTO :DWORD
Color_Paint  PROTO :DWORD
Color_setRGB PROTO :DWORD
RGB_proc     PROTO :DWORD,:DWORD
DestroyR     PROTO

.data
	;--COLOR_DIALOG
	mdc     dd 0
	mdc2    dd 0
	sc_R    dd 0
	sc_G    dd 0
	sc_B    dd 0
	curDC   dd 0
	R_curX  dd 0
	G_curX  dd 0
	B_curX  dd 0
	sys_col dd 0
	Rr      RECT <72,162,218,177>
	Gr      RECT <72,178,218,193>
	Br      RECT <72,194,218,209>
	RGB_r   RECT <0,0,140,15>
	rc_Cur1 RECT <0,0,40,40>
	rc_Cur2 RECT <150,25,190,65>
	R_c     db 0
	G_c     db 0
	B_c     db 0
	color   dd 0
	hbit    dd 0
	cursor  dd 0
	rgb_cur1 dd 0
	rgb_cur2 dd 0
	rgb_cur3 dd 0
	cur_y    dd 127
	clipped  dd 0
	rc_scroll RECT <0,0,20,142>
	rc_inv    RECT <100,16,120,159>
	rc_RGB    RECT <80,25,100,153>
	brushes dd 24 dup (0)
	c_hands dd 24 dup (0)
.data?
	hInstance dd ?
	
.code

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD

    push    hInst
    pop     hInstance
    mov     eax,TRUE
    ret

DllEntry Endp

Color_izer proc hWin:DWORD, init_color:DWORD

	mov    eax,   init_color
	mov    color, eax
	invoke DialogBoxParam, hInstance, 3000, hWin, ADDR ColorDlgProc, 0
	ret
Color_izer endp

ColorDlgProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL buf[32]:BYTE

	LOCAL holdM1:POINT
	LOCAL holdM2:POINT
	LOCAL holdM:RECT
	
	.if uMsg == WM_INITDIALOG
		invoke Color_Init, hWin
	.elseif uMsg == WM_COMMAND
		HIWORD wParam
		.if eax == STN_CLICKED
			LOWORD wParam
			.if eax == 2001
				mov    ecx, 00FFFFFFh;;
			.elseif eax == 2002
				mov    ecx, 0000FFFFh;;
			.elseif eax == 2003
				mov    ecx, 00FFFF00h;;
			.elseif eax == 2004
				mov    ecx, 000000FFh;;
			.elseif eax == 2005
				mov    ecx, 00C0FFC0h;;
			.elseif eax == 2006
				mov    ecx, 00FF8080h;;
			.elseif eax == 2007
				mov    ecx, 00FF80FFh;;
			.elseif eax == 2008
				mov    ecx, 00808080h;;
			.elseif eax == 2009
				mov    ecx, 00C0C0C0h;;
			.elseif eax == 2010
				mov    ecx, 0000C0C0h;;
			.elseif eax == 2011
				mov    ecx, 00C0C000h;;
			.elseif eax == 2012
				mov    ecx, 000000C0h;;
			.elseif eax == 2013
				mov    ecx, 0000FF00h;;
			.elseif eax == 2014
				mov    ecx, 00FF0000h;;
			.elseif eax == 2015
				mov    ecx, 00FF00FFh;;
			.elseif eax == 2016
				mov    ecx, 00404040h;;
			.elseif eax == 2017
				mov    ecx, 00808080h;;
			.elseif eax == 2018
				mov    ecx, 00008080h;;
			.elseif eax == 2019
				mov    ecx, 00808000h;;
			.elseif eax == 2020
				mov    ecx, 00000080h;;
			.elseif eax == 2021	
				mov    ecx, 00008000h;;
			.elseif eax == 2022	
				mov    ecx, 00800000h;;
			.elseif eax == 2023	
				mov    ecx, 00800080h;;
			.elseif eax == 2024
				mov    ecx, 00000000h;;
			.elseif eax == 3040
				invoke SendDlgItemMessage, hWin, 3030, WM_GETTEXT, 32, ADDR buf
				invoke htodw, ADDR buf
				mov    color, eax
				invoke DestroyR
				invoke EndDialog, hWin, color
				ret
			.elseif eax == 3050
				invoke DestroyR
				invoke EndDialog, hWin, -1
				ret
			.endif
			mov    color, ecx
			invoke RGB_proc, 0ffffffh, ecx
			mov    cur_y, 127
			invoke InvalidateRect, hWin, ADDR rc_RGB,  FALSE
			invoke InvalidateRect, hWin, ADDR rc_Cur2, FALSE
			invoke InvalidateRect, hWin, ADDR rc_inv,  FALSE
			invoke dw2hex, color, ADDR buf
			invoke SendDlgItemMessage,hWin,3030,WM_SETTEXT,0,ADDR buf
			invoke SendDlgItemMessage,hWin,3020,CB_GETCURSEL,0,0
			.if eax
				invoke SendDlgItemMessage,hWin,3020,CB_SETCURSEL,0,0
			.endif
			invoke Color_setRGB, hWin
		.elseif eax == CBN_SELCHANGE
			invoke SendDlgItemMessage,hWin,3020,CB_GETCURSEL,0,0
			.if eax
				dec    eax
				mov    ecx,    eax
				or     ecx,    80000000h
				mov    color,  ecx
				invoke dw2hex, ecx, ADDR buf
				invoke SendDlgItemMessage, hWin, 3030, WM_SETTEXT, 0, ADDR buf
				mov    eax, color
				and    eax, 0ffh
				invoke GetSysColor,eax
				mov    color, eax
				invoke Color_setRGB, hWin
				invoke RGB_proc,0ffffffh, color
				mov    cur_y, 127
				invoke InvalidateRect, hWin, ADDR rc_RGB,  FALSE
				invoke InvalidateRect, hWin, ADDR rc_Cur2, FALSE
				invoke InvalidateRect, hWin, ADDR rc_inv,  FALSE
			.endif			
		.endif
	.elseif uMsg == WM_LBUTTONDOWN
		HIWORD lParam
		mov    ecx, eax
		LOWORD lParam
		.if eax >= 100 && eax <= 120 && ecx > 15 && ecx <= 159
			m2m    holdM1.x, rc_inv.left
			m2m    holdM1.y, rc_inv.top
			invoke ClientToScreen, hWin, ADDR holdM1
			m2m    holdM2.x, rc_inv.right
			m2m    holdM2.y, rc_inv.bottom
			invoke ClientToScreen, hWin, ADDR holdM2
			invoke SetRect,    ADDR holdM, holdM1.x, holdM1.y, holdM2.x, holdM2.y
			invoke ClipCursor, ADDR holdM
			mov    clipped, 1
			HIWORD lParam
			.if eax >= 24 && eax < 152
				sub    eax,   24
				mov    cur_y, eax
				invoke InvalidateRect,hWin,ADDR rc_inv,0
			.elseif cur_y != 0 || cur_y != 127
				.if eax < 24
					mov    cur_y, 0
				.else
					mov    cur_y, 127
				.endif
				invoke InvalidateRect,hWin,ADDR rc_inv,0
			.endif
			;----------------
			invoke GetPixel, mdc, 1, cur_y
			mov    color, eax
			invoke InvalidateRect, hWin, ADDR rc_Cur2, FALSE
			;----------------
			invoke Color_setRGB, hWin
			invoke dw2hex,color, ADDR buf
			invoke SendDlgItemMessage, hWin, 3030, WM_SETTEXT, 0, ADDR buf
			invoke SendDlgItemMessage, hWin, 3020, CB_GETCURSEL, 0, 0
			.if eax
				invoke SendDlgItemMessage, hWin, 3020, CB_SETCURSEL, 0, 0
			.endif
		.elseif eax >= 80 && eax <= 207 && ecx > 159
			.if ecx <= 177 
				sub eax, 80
				mov R_curX, eax
				and color, 0ffff00h
				shl eax, 1
				or  color, eax
				;--------
				invoke InvalidateRect, hWin, ADDR Rr, 0
				m2m    holdM1.x, Rr.left
				m2m    holdM1.y, Rr.top
				invoke ClientToScreen, hWin, ADDR holdM1
				m2m    holdM2.x, Rr.right
				m2m    holdM2.y, Rr.bottom
				invoke ClientToScreen, hWin, ADDR holdM2
				invoke SetRect,    ADDR holdM, holdM1.x, holdM1.y, holdM2.x, holdM2.y
				invoke ClipCursor, ADDR holdM
				mov    clipped, 1
				invoke SendDlgItemMessage, hWin, 3020, CB_GETCURSEL, 0, 0
				.if eax
					invoke SendDlgItemMessage, hWin, 3020, CB_SETCURSEL, 0, 0
				.endif
			.elseif ecx <= 193
				sub eax, 80
				mov G_curX, eax
				and color, 0ff00ffh
				shl eax, 1
				shl eax, 8
				or  color, eax
				;--------
				invoke InvalidateRect, hWin, ADDR Gr, 0
				m2m    holdM1.x, Gr.left
				m2m    holdM1.y, Gr.top
				invoke ClientToScreen, hWin, ADDR holdM1
				m2m    holdM2.x, Gr.right
				m2m    holdM2.y, Gr.bottom
				invoke ClientToScreen, hWin, ADDR holdM2
				invoke SetRect,    ADDR holdM, holdM1.x, holdM1.y, holdM2.x, holdM2.y
				invoke ClipCursor, ADDR holdM
				mov    clipped, 1
				invoke SendDlgItemMessage, hWin, 3020, CB_GETCURSEL, 0, 0
				.if eax
					invoke SendDlgItemMessage, hWin, 3020, CB_SETCURSEL, 0, 0
				.endif
			.elseif ecx <= 209
				sub eax, 80
				mov B_curX, eax
				and color, 0ffffh
				shl eax, 1
				shl eax, 16
				or  color, eax
				;--------
				invoke InvalidateRect, hWin, ADDR Br, 0
				m2m    holdM1.x, Br.left
				m2m    holdM1.y, Br.top
				invoke ClientToScreen, hWin, ADDR holdM1
				m2m    holdM2.x, Br.right
				m2m    holdM2.y, Br.bottom
				invoke ClientToScreen, hWin, ADDR holdM2
				invoke SetRect,    ADDR holdM, holdM1.x, holdM1.y, holdM2.x, holdM2.y
				invoke ClipCursor, ADDR holdM
				mov    clipped, 1
				invoke SendDlgItemMessage, hWin, 3020, CB_GETCURSEL, 0, 0
				.if eax
					invoke SendDlgItemMessage, hWin, 3020, CB_SETCURSEL, 0, 0
				.endif
			.endif
			invoke RGB_proc, 0ffffffh, color
			mov    cur_y,    127
			invoke InvalidateRect, hWin, ADDR rc_Cur2, FALSE
			invoke InvalidateRect, hWin, ADDR rc_RGB,  FALSE
			invoke InvalidateRect, hWin, ADDR rc_inv,  FALSE
			;----------------
			invoke dw2hex,color, ADDR buf
			invoke SendDlgItemMessage, hWin, 3030, WM_SETTEXT, 0, ADDR buf
		.endif
	.elseif uMsg == WM_LBUTTONUP
		mov    clipped,    0
		invoke ClipCursor, 0
	.elseif uMsg == WM_MOUSEMOVE
		.if clipped == 0
			ret
		.endif
		.if wParam == MK_LBUTTON
			HIWORD lParam
			mov    ecx, eax
			LOWORD lParam
			.if eax >= 100 && eax <= 120 && ecx <= 159
				HIWORD lParam
				.if eax >= 24 && eax < 152
					sub    eax,   24
					mov    cur_y, eax
				.elseif cur_y != 0 || cur_y != 127
					.if eax < 24
						mov    cur_y, 0
					.else
						mov    cur_y, 127
					.endif
				.endif
				invoke GetPixel, mdc, 1, cur_y
				mov    color, eax
				invoke InvalidateRect, hWin, ADDR rc_Cur2, FALSE
				invoke InvalidateRect, hWin, ADDR rc_inv,  FALSE
				;----------------
				invoke Color_setRGB, hWin
				;----------------
				invoke dw2hex,color,ADDR buf
				invoke SendDlgItemMessage,hWin,3030,WM_SETTEXT,0,ADDR buf
			.elseif eax >= 80 && eax <= 207
				.if ecx <= 177 
					sub eax, 80
					mov R_curX, eax
					and color, 0ffff00h
					shl eax, 1
					.if eax == 0FEh
						mov eax, 0ffh
					.endif
					or  color, eax
					invoke InvalidateRect,hWin,ADDR Rr,0
				.elseif ecx <= 193
					sub eax, 80
					mov G_curX, eax
					and color, 0ff00ffh
					shl eax, 1
					shl eax, 8
					.if eax == 0FE00h
						mov eax, 0ff00h
					.endif
					or  color, eax
					invoke InvalidateRect,hWin,ADDR Gr,0
				.elseif ecx <= 209
					sub eax, 80
					mov B_curX, eax
					and color, 0ffffh
					shl eax, 1
					shl eax, 16
					.if eax == 0FE0000h
						mov eax, 0ff0000h
					.endif
					or  color, eax
					invoke InvalidateRect,hWin,ADDR Br,0
				.endif
				invoke RGB_proc, 0ffffffh, color
				mov    cur_y,    127
				invoke InvalidateRect, hWin, ADDR rc_Cur2, FALSE
				invoke InvalidateRect, hWin, ADDR rc_RGB,  FALSE
				invoke InvalidateRect, hWin, ADDR rc_inv,  FALSE
				;---------------
				invoke dw2hex,color,ADDR buf
				invoke SendDlgItemMessage,hWin,3030,WM_SETTEXT,0,ADDR buf
			.endif
		.endif	
	.elseif uMsg == WM_PAINT
		invoke Color_Paint, hWin
	.elseif uMsg == WM_CTLCOLORSTATIC
		mov    ecx, lParam
		mov    eax, 0
		.if ecx == dword ptr [c_hands]
			mov eax, dword ptr [brushes]
		.elseif ecx == dword ptr [c_hands+4]
			mov eax, dword ptr [brushes+4]
		.elseif ecx == dword ptr [c_hands+8]
			mov eax, dword ptr [brushes+8]
		.elseif ecx == dword ptr [c_hands+12]
			mov eax, dword ptr [brushes+12]
		.elseif ecx == dword ptr [c_hands+16]
			mov eax, dword ptr [brushes+16]
		.elseif ecx == dword ptr [c_hands+20]
			mov eax, dword ptr [brushes+20]
		.elseif ecx == dword ptr [c_hands+24]
			mov eax, dword ptr [brushes+24]
		.elseif ecx == dword ptr [c_hands+28]
			mov eax, dword ptr [brushes+28]
		.elseif ecx == dword ptr [c_hands+32]
			mov eax, dword ptr [brushes+32]
		.elseif ecx == dword ptr [c_hands+36]
			mov eax, dword ptr [brushes+36]
		.elseif ecx == dword ptr [c_hands+40]
			mov eax, dword ptr [brushes+40]
		.elseif ecx == dword ptr [c_hands+44]
			mov eax, dword ptr [brushes+44]
		.elseif ecx == dword ptr [c_hands+48]
			mov eax, dword ptr [brushes+48]
		.elseif ecx == dword ptr [c_hands+52]
			mov eax, dword ptr [brushes+52]
		.elseif ecx == dword ptr [c_hands+56]
			mov eax, dword ptr [brushes+56]
		.elseif ecx == dword ptr [c_hands+60]
			mov eax, dword ptr [brushes+60]
		.elseif ecx == dword ptr [c_hands+64]
			mov eax, dword ptr [brushes+64]
		.elseif ecx == dword ptr [c_hands+68]
			mov eax, dword ptr [brushes+68]
		.elseif ecx == dword ptr [c_hands+72]
			mov eax, dword ptr [brushes+72]
		.elseif ecx == dword ptr [c_hands+76]
			mov eax, dword ptr [brushes+76]
		.elseif ecx == dword ptr [c_hands+80]
			mov eax, dword ptr [brushes+80]
		.elseif ecx == dword ptr [c_hands+84]
			mov eax, dword ptr [brushes+84]
		.elseif ecx == dword ptr [c_hands+88]
			mov eax, dword ptr [brushes+88]
		.elseif ecx == dword ptr [c_hands+92]
			mov eax, dword ptr [brushes+92]
		.endif
		ret
	.elseif uMsg == WM_CLOSE
		invoke DestroyR
		invoke EndDialog,hWin,-1
	.endif
	mov    eax, FALSE
	ret
ColorDlgProc endp

Color_Init proc hWin:DWORD
	LOCAL dc:DWORD
	LOCAL init_c:DWORD
	LOCAL buf[32]:BYTE
		
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("NONE")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("0_SCROLLBAR")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("1_DESKTOP")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("2_ACTIVECAPTION")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("3_INACTIVECAPTION")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("4_MENU")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("5_WINDOW")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("6_WINDOWFRAME")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("7_MENUTEXT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("8_WINDOWTEXT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("9_CAPTIONTEXT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("10_ACTIVEBORDER")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("11_INACTIVEBORDER")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("12_APPWORKSPACE")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("13_HIGHLIGHT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("14_HIGHLIGHTTEXT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("15_BTNFACE")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("16_BTNSHADOW")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("17_GRAYTEXT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("18_BTNTEXT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("19_INACTIVECAPTIONTEXT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("20_BTNHIGHLIGHT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("21_3DDKSHADOW")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("22_3DLIGHT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("23_INFOTEXT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("24_INFOBK")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("25_-")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("26_HOTLIGHT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("27_GRADIENTACTIVECAPTION")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("28_GRADIENTINACTIVECAPTION")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("29_MENUHILIGHT")
	invoke SendDlgItemMessage,hWin,3020,CB_ADDSTRING,0,CADD("30_MENUBAR")
	invoke SendDlgItemMessage,hWin,3020,CB_SETCURSEL,0,0
	mov    dword ptr [c_hands],    FUNC(GetDlgItem,hWin,2001)
	mov    dword ptr [c_hands+4],  FUNC(GetDlgItem,hWin,2002)
	mov    dword ptr [c_hands+8],  FUNC(GetDlgItem,hWin,2003)
	mov    dword ptr [c_hands+12], FUNC(GetDlgItem,hWin,2004)
	mov    dword ptr [c_hands+16], FUNC(GetDlgItem,hWin,2005)
	mov    dword ptr [c_hands+20], FUNC(GetDlgItem,hWin,2006)
	mov    dword ptr [c_hands+24], FUNC(GetDlgItem,hWin,2007)
	mov    dword ptr [c_hands+28], FUNC(GetDlgItem,hWin,2008)
	;----------
	mov    dword ptr [c_hands+32], FUNC(GetDlgItem,hWin,2009)
	mov    dword ptr [c_hands+36], FUNC(GetDlgItem,hWin,2010)
	mov    dword ptr [c_hands+40], FUNC(GetDlgItem,hWin,2011)
	mov    dword ptr [c_hands+44], FUNC(GetDlgItem,hWin,2012)
	mov    dword ptr [c_hands+48], FUNC(GetDlgItem,hWin,2013)
	mov    dword ptr [c_hands+52], FUNC(GetDlgItem,hWin,2014)
	mov    dword ptr [c_hands+56], FUNC(GetDlgItem,hWin,2015)
	mov    dword ptr [c_hands+60], FUNC(GetDlgItem,hWin,2016)
	;----------
	mov    dword ptr [c_hands+64], FUNC(GetDlgItem, hWin, 2017)
	mov    dword ptr [c_hands+68], FUNC(GetDlgItem, hWin, 2018)
	mov    dword ptr [c_hands+72], FUNC(GetDlgItem, hWin, 2019)
	mov    dword ptr [c_hands+76], FUNC(GetDlgItem, hWin, 2020)
	mov    dword ptr [c_hands+80], FUNC(GetDlgItem, hWin, 2021)
	mov    dword ptr [c_hands+84], FUNC(GetDlgItem, hWin, 2022)
	mov    dword ptr [c_hands+88], FUNC(GetDlgItem, hWin, 2023)
	mov    dword ptr [c_hands+92], FUNC(GetDlgItem, hWin, 2024)
	;----
	mov    dword ptr [brushes],    FUNC(CreateSolidBrush, 00FFFFFFh)
	mov    dword ptr [brushes+4],  FUNC(CreateSolidBrush, 0000FFFFh)
	mov    dword ptr [brushes+8],  FUNC(CreateSolidBrush, 00FFFF00h)
	mov    dword ptr [brushes+12], FUNC(CreateSolidBrush, 000000FFh)
	mov    dword ptr [brushes+16], FUNC(CreateSolidBrush, 00C0FFC0h)
	mov    dword ptr [brushes+20], FUNC(CreateSolidBrush, 00FF8080h)
	mov    dword ptr [brushes+24], FUNC(CreateSolidBrush, 00FF80FFh)
	mov    dword ptr [brushes+28], FUNC(CreateSolidBrush, 00808080h);
	;----
	mov    dword ptr [brushes+32], FUNC(CreateSolidBrush, 00C0C0C0h)
	mov    dword ptr [brushes+36], FUNC(CreateSolidBrush, 0000C0C0h)
	mov    dword ptr [brushes+40], FUNC(CreateSolidBrush, 00C0C000h)
	mov    dword ptr [brushes+44], FUNC(CreateSolidBrush, 000000C0h)
	mov    dword ptr [brushes+48], FUNC(CreateSolidBrush, 0000FF00h)
	mov    dword ptr [brushes+52], FUNC(CreateSolidBrush, 00FF0000h)
	mov    dword ptr [brushes+56], FUNC(CreateSolidBrush, 00FF00FFh)
	mov    dword ptr [brushes+60], FUNC(CreateSolidBrush, 00404040h);
	;----
	mov    dword ptr [brushes+64], FUNC(CreateSolidBrush, 00808080h)
	mov    dword ptr [brushes+68], FUNC(CreateSolidBrush, 00008080h)
	mov    dword ptr [brushes+72], FUNC(CreateSolidBrush, 00808000h)
	mov    dword ptr [brushes+76], FUNC(CreateSolidBrush, 00000080h)
	mov    dword ptr [brushes+80], FUNC(CreateSolidBrush, 00008000h)
	mov    dword ptr [brushes+84], FUNC(CreateSolidBrush, 00800000h)
	mov    dword ptr [brushes+88], FUNC(CreateSolidBrush, 00800080h)
	mov    dword ptr [brushes+92], FUNC(CreateSolidBrush, 00000000h);
	;---------------
	mov    dc,    FUNC(GetDC, hWin)
	mov    mdc,   FUNC(CreateCompatibleDC,     dc)
	mov    hbit,  FUNC(CreateCompatibleBitmap, dc, 20, 128)
	invoke SelectObject, mdc, eax
	invoke DeleteObject, eax
	invoke DeleteObject, hbit
	mov    mdc2,  FUNC(CreateCompatibleDC,     dc)
	mov    hbit,  FUNC(CreateCompatibleBitmap, dc, 20, 140)
	invoke SelectObject, mdc2, eax
	invoke DeleteObject, eax
	invoke DeleteObject, hbit
	;---------------------
	mov    sc_R,  FUNC(CreateCompatibleDC,     dc)
	mov    hbit,  FUNC(CreateCompatibleBitmap, dc, 140, 15)
	invoke SelectObject, sc_R, eax
	invoke DeleteObject, eax
	invoke DeleteObject, hbit
	mov    sc_G,  FUNC(CreateCompatibleDC,     dc)
	mov    hbit,  FUNC(CreateCompatibleBitmap, dc, 140, 15)
	invoke SelectObject, sc_G, eax
	invoke DeleteObject, eax
	invoke DeleteObject, hbit
	mov    sc_B,  FUNC(CreateCompatibleDC,     dc)
	mov    hbit,  FUNC(CreateCompatibleBitmap, dc, 140, 15)
	invoke SelectObject, sc_B, eax
	invoke DeleteObject, eax
	invoke DeleteObject, hbit
	mov    curDC, FUNC(CreateCompatibleDC,     dc)
	mov    hbit,  FUNC(CreateCompatibleBitmap, dc, 40, 40)
	invoke SelectObject, curDC,eax
	invoke DeleteObject, eax
	invoke DeleteObject, hbit
	invoke ReleaseDC,    hWin, dc
	;---------------
	mov    eax,    color
	mov    init_c, eax
	shr    eax,    24
	.if eax == 80h
		mov    eax,    color	
		and    eax,    0ffh
		invoke GetSysColor, eax
		mov    color, eax
	.else
		mov    eax,    color
		and    eax,    0ffffffh
		mov    color,  eax
	.endif
	invoke RGB_proc, 0ffffffh, color
	invoke Color_setRGB, hWin
	invoke dw2hex, init_c, ADDR buf
	invoke SendDlgItemMessage, hWin, 3030, WM_SETTEXT, 0, ADDR buf
	.if init_c > 0ffffffh
		and    init_c, 0ffh
		inc    init_c
		invoke SendDlgItemMessage, hWin, 3020, CB_SETCURSEL, init_c, 0
	.endif
	;---------------
	mov    cursor,   FUNC(LoadImage, hInstance, 40000, IMAGE_ICON, 13, 13, LR_DEFAULTCOLOR)
	mov    rgb_cur1, FUNC(LoadImage, hInstance, 40001, IMAGE_ICON, 13, 13, LR_DEFAULTCOLOR)
	mov    rgb_cur2, FUNC(LoadImage, hInstance, 40002, IMAGE_ICON, 13, 13, LR_DEFAULTCOLOR)
	mov    rgb_cur3, FUNC(LoadImage, hInstance, 40003, IMAGE_ICON, 13, 13, LR_DEFAULTCOLOR)
	ret

Color_Init endp

Color_Paint proc hWin:DWORD
	LOCAL ps:PAINTSTRUCT
	LOCAL count:DWORD
	
	invoke BeginPaint,hWin,ADDR ps
	mov    sys_col, FUNC(GetSysColor,COLOR_BTNFACE)
	invoke SetBkColor,mdc2,eax
	invoke ExtTextOut,mdc2,0,0,ETO_OPAQUE,ADDR rc_scroll,0,0,0
	invoke DrawIconEx,mdc2,0,cur_y,cursor,13,13,0,0,DI_NORMAL
	invoke BitBlt,ps.hdc,80,25,20,128,mdc,0,0,SRCCOPY
	invoke BitBlt,ps.hdc,101,19,20,142,mdc2,0,0,SRCCOPY
	;---------
	invoke SetBkColor,sc_R,sys_col
	invoke ExtTextOut,sc_R,0,0,ETO_OPAQUE,ADDR RGB_r,0,0,0
	mov    count,1
@@:		
	invoke SetPixelV,sc_R,count,7,0
	add    count, 3
	cmp    count, 140
	jl     @B
	invoke DrawIconEx,sc_R,R_curX,1,rgb_cur1,13,13,0,0,DI_NORMAL
	invoke BitBlt,ps.hdc,74,162,140,15,sc_R,0,0,SRCCOPY
	invoke SetBkColor,sc_G, sys_col
	invoke ExtTextOut,sc_G,0,0,ETO_OPAQUE,ADDR RGB_r,0,0,0
	mov    count,1
@@:		
	invoke SetPixelV,sc_G,count,7,0
	add    count, 3
	cmp    count, 140
	jl     @B
	invoke DrawIconEx,sc_G,G_curX,1,rgb_cur2,13,13,0,0,DI_NORMAL
	invoke BitBlt,ps.hdc,74,178,140,15,sc_G,0,0,SRCCOPY
	invoke SetBkColor,sc_B, sys_col
	invoke ExtTextOut,sc_B,0,0,ETO_OPAQUE,ADDR RGB_r,0,0,0
	mov    count,1
@@:		
	invoke SetPixelV,sc_B,count,7,0
	add    count, 3
	cmp    count, 140
	jl     @B
	invoke DrawIconEx,sc_B,B_curX,1,rgb_cur3,13,13,0,0,DI_NORMAL
	invoke BitBlt,ps.hdc,74,194,140,15,sc_B,0,0,SRCCOPY
	;---------
	invoke SetBkColor,curDC,color
	invoke ExtTextOut,curDC,0,0,ETO_OPAQUE,ADDR rc_Cur1,0,0,0		
	invoke BitBlt,ps.hdc,150,25,40,40,curDC,0,0,SRCCOPY
	invoke EndPaint,hWin,ADDR ps
	ret

Color_Paint endp

Color_setRGB proc hWin:DWORD
	;---get R
	mov    eax, color
	and    eax, 0000ffh
	shr    eax, 1
	mov    R_curX,eax
	invoke InvalidateRect,hWin,ADDR Rr,0
	;---get G
	mov    eax, color
	and    eax, 00ff00h
	shr    eax, 8
	shr    eax, 1
	mov    G_curX,eax
	invoke InvalidateRect,hWin,ADDR Gr,0
	;---get B
	mov    eax, color
	and    eax, 0ff0000h
	shr    eax, 16
	shr    eax, 1
	mov    B_curX,eax
	invoke InvalidateRect,hWin,ADDR Br,0
	ret

Color_setRGB endp

RGB_proc PROC F_S:DWORD,F_E:DWORD
	LOCAL S_R:DWORD,S_G:DWORD,S_B:DWORD
	LOCAL E_R:DWORD,E_G:DWORD,E_B:DWORD
	LOCAL gal:RECT,br:DWORD
	LOCAL R:BYTE,G:BYTE,B:BYTE,XXX:DWORD

	mov    eax,F_S
	and    eax,000000FFh
	mov    S_R,eax
	mov    eax,F_S
	shr    eax,8
	and    eax,000000FFh
	mov    S_G,eax
	mov    eax,F_S
	shr    eax,16
	and    eax,000000FFh
	mov    S_B,eax
	mov    eax,F_E
	and    eax,000000FFh
	sub    eax,S_R
	mov    E_R,eax
	mov    eax,F_E
	shr    eax,8
	and    eax,000000FFh
	sub    eax,S_G
	mov    E_G,eax
	mov    eax,F_E
	shr    eax,16
	and    eax,000000FFh
	sub    eax,S_B
	mov    E_B,eax
	mov    gal.top, 0
	mov    gal.left,0
	mov    gal.right,20
	mov    XXX,0
here:
	invoke MulDiv,XXX,128,255
	mov    gal.top,eax
	mov    eax,XXX
	inc    eax
	invoke MulDiv,eax,128,255
	mov    gal.bottom,eax
	invoke MulDiv,XXX,E_R,255
	add    eax,S_R
	mov    R,al
	invoke MulDiv,XXX,E_G,255
	add    eax,S_G
	mov    G,al
	invoke MulDiv,XXX,E_B,255
	add    eax,S_B
	mov    B,al
	RGB R,G,B
	invoke SetBkColor, mdc,eax
	invoke ExtTextOut, mdc,0,0,ETO_OPAQUE,ADDR gal,0,0,0
	inc    XXX
	.IF    XXX < 255
		jmp here
	.ELSEIF XXX==255
		ret
	.ENDIF
	ret
RGB_proc ENDP

DestroyR proc
	LOCAL count:DWORD
	
	invoke DeleteObject, hbit
	invoke DeleteDC, mdc
	invoke DeleteDC, mdc2
	invoke DeleteDC, sc_R
	invoke DeleteDC, sc_G
	invoke DeleteDC, sc_B
	invoke DeleteDC, curDC
	invoke DestroyIcon, rgb_cur1
	invoke DestroyIcon, rgb_cur2
	invoke DestroyIcon, rgb_cur3
	invoke DestroyIcon, cursor
	mov    count, 0
@@:	
	mov    edx, count
	mov    ecx, dword ptr [brushes+edx]
	invoke DeleteObject, ecx
	add    count, 4
	cmp    count, 96
	jb     @B
	ret

DestroyR endp

End DllEntry
